<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import EmailField from '$lib/components/fields/EmailField.svelte';
  import { goto } from '$app/navigation';
  import { axiosInstance } from '$lib/config';
  import TextField from '$lib/components/fields/TextField.svelte';
  import { getContext } from 'svelte';

  let showCodeField = false,
    errors: any[] = [],
    email = '',
    code = '',
    isLoading = false;

  const user = getContext('user') as SvelteStore<any>;

  async function requestCode(email: string) {
    errors = [];
    if (email) {
      try {
        isLoading = true;
        const { status } = await axiosInstance.post('/auth/request-code', { email });

        if (status === 200) {
          showCodeField = true;
        }
      } catch (error: any) {
        if (error?.response?.status === 404) {
          errors.push('Аккаунт не найден.');
        } else {
          errors.push('Возникла ошибка, попробуйте повторить действие или свяжитесь со службой поддержки');
        }

        errors = [...errors];
      } finally {
        isLoading = false;
      }
    }
  }

  async function verifyCode(email: string, code: string) {
    errors = [];
    if (email) {
      try {
        const response = await axiosInstance.post('/auth/validate-code', { email, code });

        isLoading = true;

        if (response.status === 200) {
          $user = response.data;

          goto('/');
        } else {
          errors.push('Возникла ошибка, попробуйте повторить действие или свяжитесь со службой поддержки');
          errors = [...errors];
        }
      } catch (error) {
        errors.push('Возникла ошибка, попробуйте повторить действие или свяжитесь со службой поддержки');
        errors = [...errors];
      } finally {
        isLoading = false;
      }
    }
  }
</script>

<form method="post" on:submit|preventDefault class="flex flex-col mx-auto justify-center h-screen max-w-md">
    <section class="text-center mb-5 lg:mb-8">
        <h1 class="text-6xl mb-2 font-serif">Авторизация</h1>
    </section>

    {#if !showCodeField}
        <EmailField required bind:value={email} label="Email" name="email"/>
    {/if}
    {#if showCodeField}
        <p class="text-neutral-600 text-center">
            Вам на почту было отправлено письмо с кодом
            <button
                type="button"
                class="text-center text-blue-700 font-serif lg:text-base hover:underline decoration-2 decoration-blue-700"
                on:click={() => showCodeField = false}
            >
                Отправить повторно
            </button>
        </p>
        <TextField required label="Код" name="code" bind:value={code}/>
    {/if}

    <Button
        on:click={() => {
          if (showCodeField) {
              verifyCode(email, code);
          } else {
              requestCode(email);
          }
        }}
        type="button"
        class="mb-3 lg:mb-5"
        disabled={isLoading}
    >
        Войти
    </Button>

    <section>
        {#each errors as error}
            <p class="text-red-700">{error}</p>
        {/each}
    </section>

    <a
        href="/"
        class="text-center text-sm lg:text-base hover:underline decoration-2 decoration-blue-700"
    >
        &larr; Обратно
    </a>
</form>

<style lang="postcss">
    input {
        @apply appearance-none transition duration-200 outline-none
        border-2 border-gray-300
        py-2 px-3 rounded-full w-full
        focus-within:border-blue-700 focus-within:bg-white;
    }
</style>